<!-- LANL:license
 ...........................................................................
 - This SOFTWARE has been authored by an employee or employees of the
 - University of California, operator of the Los Alamos National Laboratory
 - under Contract No. W-7405-ENG-36 with the U.S. Department of Energy.
 - The U.S. Government has rights to use, reproduce, and distribute this
 - SOFTWARE.  The public may copy, distribute, prepare derivative works and
 - publicly display this SOFTWARE without charge, provided that this Notice
 - and any statement of authorship are reproduced on all copies.  Neither
 - the Government nor the University makes any warranty, express or implied,
 - or assumes any liability or responsibility for the use of this SOFTWARE.
 - If SOFTWARE is modified to produce derivative works, such modified
 - SOFTWARE should be clearly marked, so as not to confuse it with the
 - version available from LANL.
 ...........................................................................
 - LANL:license
 ...........................................................................
 -->

<!--
  - common templates for creating CCA files
  -
  - decl-list-struct <scope>
  -
  -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:output method="text"/>


<!--
  - decl-list-struct <scope>
  -->
<xsl:template name="decl-list-struct">
  <xsl:text>  PyObject_HEAD</xsl:text> <xsl:value-of select="$nl"/>
  <xsl:text>  PyObject* services;</xsl:text> <xsl:value-of select="$nl"/>
</xsl:template>


<!--
  - abbreviation : choose abbreviation or name if no abbreviation
  -->
<xsl:template name="abbreviation">
  <xsl:param name="name"/>
  <xsl:param name="abbrev"/>
  <xsl:choose>
    <xsl:when test="$abbrev != ''">
      <xsl:value-of select="$abbrev"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$name"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


</xsl:stylesheet>
