<!-- LANL:license
 ...........................................................................
 - This SOFTWARE has been authored by an employee or employees of the
 - University of California, operator of the Los Alamos National Laboratory
 - under Contract No. W-7405-ENG-36 with the U.S. Department of Energy.
 - The U.S. Government has rights to use, reproduce, and distribute this
 - SOFTWARE.  The public may copy, distribute, prepare derivative works and
 - publicly display this SOFTWARE without charge, provided that this Notice
 - and any statement of authorship are reproduced on all copies.  Neither
 - the Government nor the University makes any warranty, express or implied,
 - or assumes any liability or responsibility for the use of this SOFTWARE.
 - If SOFTWARE is modified to produce derivative works, such modified
 - SOFTWARE should be clearly marked, so as not to confuse it with the
 - version available from LANL.
 ...........................................................................
 - LANL:license
 ...........................................................................
 -->

<!--
  - common templates for creating sidl/babel files
  -
  - param-id <arg>
  - method-id <method>
  -
  -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:import href="common-C.xsl"/>
<xsl:import href="type-conv-sidl.xsl"/>
<xsl:output method="text"/>


<!--
  - param-id <arg>
  -   override common-C to add lowercase argument name
  -->
<xsl:template name="param-id">
  <xsl:call-template name="lower-case">
    <xsl:with-param name="symbol" select="@name"/>
  </xsl:call-template>
</xsl:template>


<!--
  - method-id <method>
  -->
<xsl:template name="method-id">
  <xsl:call-template name="name-ifnot-alias"/>
  <xsl:if test="@overloaded = 'yes'">
    <xsl:if test="@abbrev">
      <xsl:value-of select="@abbrev"/>
    </xsl:if>
  </xsl:if>
</xsl:template>


<!--
  - function-decl <method>
  -   type-qual type-spec function-id ( param-type-list );
  -->
<xsl:template name="function-decl">
  <xsl:param name="id">
    <xsl:call-template name="function-id"/>
  </xsl:param>
  <xsl:param name="ws" select="''"/>
  <xsl:value-of select="$ws"/>
  <xsl:for-each select="return[1]/type">
    <xsl:call-template name="type-spec"/>
  </xsl:for-each>
  <xsl:text> </xsl:text>
  <xsl:value-of select="$id"/>
  <xsl:text>(</xsl:text>
  <xsl:call-template name="param-type-list"/>
  <xsl:text>);</xsl:text>
  <xsl:value-of select="$nl"/>
</xsl:template>


</xsl:stylesheet>
